<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd" >
<mapper namespace="com.bw.adv.module.activity.mapper.ActivityMapper" >
  <resultMap id="BaseResultMap" type="com.bw.adv.module.activity.model.Activity" >
    <id column="ACTIVITY_ID" property="activityId" jdbcType="BIGINT" />
    <result column="ACTIVITY_CODE" property="activityCode" jdbcType="VARCHAR" />
    <result column="ACTIVITY_VERSION" property="activityVersion" jdbcType="BIGINT" />
    <result column="ACTIVITY_TYPE_ID" property="activityTypeId" jdbcType="BIGINT" />
    <result column="CHANNEL_ID" property="channelId" jdbcType="BIGINT" />
    <result column="ACTIVITY_NAME" property="activityName" jdbcType="VARCHAR" />
    <result column="ACTIVITY_TITLE" property="activityTitle" jdbcType="VARCHAR" />
    <result column="ACTIVITY_SUB_TITLE" property="activitySubTitle" jdbcType="CHAR" />
    <result column="ACTIVITY_DESC" property="activityDesc" jdbcType="VARCHAR" />
    <result column="RULE_DESC" property="ruleDesc" jdbcType="VARCHAR" />
    <result column="ACTIVITY_IMG_1" property="activityImg1" jdbcType="VARCHAR" />
    <result column="ACTIVITY_IMG_2" property="activityImg2" jdbcType="VARCHAR" />
    <result column="ACTIVITY_IMG_3" property="activityImg3" jdbcType="VARCHAR" />
    <result column="FROM_DATE" property="fromDate" jdbcType="CHAR" />
    <result column="THRU_DATE" property="thruDate" jdbcType="CHAR" />
    <result column="CREATE_TIME" property="createTime" jdbcType="CHAR" />
    <result column="ACTIVITY_AMOUNT" property="activityAmount" jdbcType="INTEGER" />
    <result column="IS_ACTIVE" property="isActive" jdbcType="CHAR" />
  </resultMap>
  <sql id="Base_Column_List" >
    ACTIVITY_ID, ACTIVITY_CODE, ACTIVITY_VERSION, ACTIVITY_TYPE_ID, CHANNEL_ID, ACTIVITY_NAME, 
    ACTIVITY_TITLE, ACTIVITY_SUB_TITLE, ACTIVITY_DESC, RULE_DESC, ACTIVITY_IMG_1, ACTIVITY_IMG_2, 
    ACTIVITY_IMG_3, FROM_DATE, THRU_DATE, CREATE_TIME, ACTIVITY_AMOUNT, IS_ACTIVE
  </sql>
  <select id="selectByPrimaryKey" resultMap="BaseResultMap" parameterType="java.lang.Long" >
    select 
    <include refid="Base_Column_List" />
    from activity
    where ACTIVITY_ID = #{activityId,jdbcType=BIGINT}
  </select>
  
  <select id="selectAllActive" resultMap="BaseResultMap">
    select a.ACTIVITY_ID as activityId, a.ACTIVITY_CODE as activityCode, a.ACTIVITY_VERSION as activityVersion, 
    a.ACTIVITY_TYPE_ID as activityTypeId, a.CHANNEL_ID as channelId, a.ACTIVITY_NAME as activityName, 
    a.ACTIVITY_TITLE as activityTitle, a.ACTIVITY_SUB_TITLE as activitySubTitle, a.ACTIVITY_DESC as activityDesc, 
    a.RULE_DESC as ruleDesc, a.ACTIVITY_IMG_1 as activityImg1, a.ACTIVITY_IMG_2 as activityImg2, a.ACTIVITY_IMG_3 as activityImg3,
    a.FROM_DATE as fromDate, a.THRU_DATE as thruDate, a.CREATE_TIME as createTime, a.IS_ACTIVE as isActive,
    (select COUNT(1) from activity_instance  aa 
	where aa.ACTIVITY_ID = a.ACTIVITY_ID
	and aa.STATUS_ID = 2102
	) as activityAmount from activity  a 
	where a.IS_ACTIVE = 'Y' 
	GROUP BY a.ACTIVITY_ID
  </select>
  
  <select id="selectAllActiveByTypeId" resultMap="BaseResultMap">
    select a.ACTIVITY_ID as activityId, a.ACTIVITY_CODE as activityCode, a.ACTIVITY_VERSION as activityVersion, 
    a.ACTIVITY_TYPE_ID as activityTypeId, a.CHANNEL_ID as channelId, a.ACTIVITY_NAME as activityName, 
    a.ACTIVITY_TITLE as activityTitle, a.ACTIVITY_SUB_TITLE as activitySubTitle, a.ACTIVITY_DESC as activityDesc, 
    a.RULE_DESC as ruleDesc, a.ACTIVITY_IMG_1 as activityImg1, a.ACTIVITY_IMG_2 as activityImg2, a.ACTIVITY_IMG_3 as activityImg3,
    a.FROM_DATE as fromDate, a.THRU_DATE as thruDate, a.CREATE_TIME as createTime, a.IS_ACTIVE as isActive,
    (select COUNT(1) from activity_instance  aa 
	where aa.ACTIVITY_ID = a.ACTIVITY_ID
	and aa.STATUS_ID = 2102
	) as activityAmount from activity  a 
	where a.IS_ACTIVE = 'Y' and a.ACTIVITY_TYPE_ID = #{activityTypeId}
	GROUP BY a.ACTIVITY_ID
  </select>
  
  <select id="selectAll" resultMap="BaseResultMap">
    select 
    <include refid="Base_Column_List"/>
    from activity
  </select>
  
  <delete id="deleteByPrimaryKey" parameterType="java.lang.Long" >
    delete from activity
    where ACTIVITY_ID = #{activityId,jdbcType=BIGINT}
  </delete>
  <insert id="insert" parameterType="com.bw.adv.module.activity.model.Activity" >
    insert into activity (ACTIVITY_ID, ACTIVITY_CODE, ACTIVITY_VERSION, 
      ACTIVITY_TYPE_ID, CHANNEL_ID, ACTIVITY_NAME, 
      ACTIVITY_TITLE, ACTIVITY_SUB_TITLE, ACTIVITY_DESC, 
      RULE_DESC, ACTIVITY_IMG_1, ACTIVITY_IMG_2, 
      ACTIVITY_IMG_3, FROM_DATE, THRU_DATE, 
      CREATE_TIME, ACTIVITY_AMOUNT, IS_ACTIVE
      )
    values (#{activityId,jdbcType=BIGINT}, #{activityCode,jdbcType=VARCHAR}, #{activityVersion,jdbcType=BIGINT}, 
      #{activityTypeId,jdbcType=BIGINT}, #{channelId,jdbcType=BIGINT}, #{activityName,jdbcType=VARCHAR}, 
      #{activityTitle,jdbcType=VARCHAR}, #{activitySubTitle,jdbcType=CHAR}, #{activityDesc,jdbcType=VARCHAR}, 
      #{ruleDesc,jdbcType=VARCHAR}, #{activityImg1,jdbcType=VARCHAR}, #{activityImg2,jdbcType=VARCHAR}, 
      #{activityImg3,jdbcType=VARCHAR}, #{fromDate,jdbcType=CHAR}, #{thruDate,jdbcType=CHAR}, 
      #{createTime,jdbcType=CHAR}, #{activityAmount,jdbcType=INTEGER}, #{isActive,jdbcType=CHAR}
      )
  </insert>
  <insert id="insertSelective" parameterType="com.bw.adv.module.activity.model.Activity" >
    insert into activity
    <trim prefix="(" suffix=")" suffixOverrides="," >
      <if test="activityId != null" >
        ACTIVITY_ID,
      </if>
      <if test="activityCode != null" >
        ACTIVITY_CODE,
      </if>
      <if test="activityVersion != null" >
        ACTIVITY_VERSION,
      </if>
      <if test="activityTypeId != null" >
        ACTIVITY_TYPE_ID,
      </if>
      <if test="channelId != null" >
        CHANNEL_ID,
      </if>
      <if test="activityName != null" >
        ACTIVITY_NAME,
      </if>
      <if test="activityTitle != null" >
        ACTIVITY_TITLE,
      </if>
      <if test="activitySubTitle != null" >
        ACTIVITY_SUB_TITLE,
      </if>
      <if test="activityDesc != null" >
        ACTIVITY_DESC,
      </if>
      <if test="ruleDesc != null" >
        RULE_DESC,
      </if>
      <if test="activityImg1 != null" >
        ACTIVITY_IMG_1,
      </if>
      <if test="activityImg2 != null" >
        ACTIVITY_IMG_2,
      </if>
      <if test="activityImg3 != null" >
        ACTIVITY_IMG_3,
      </if>
      <if test="fromDate != null" >
        FROM_DATE,
      </if>
      <if test="thruDate != null" >
        THRU_DATE,
      </if>
      <if test="createTime != null" >
        CREATE_TIME,
      </if>
      <if test="activityAmount != null" >
        ACTIVITY_AMOUNT,
      </if>
      <if test="isActive != null" >
        IS_ACTIVE,
      </if>
    </trim>
    <trim prefix="values (" suffix=")" suffixOverrides="," >
      <if test="activityId != null" >
        #{activityId,jdbcType=BIGINT},
      </if>
      <if test="activityCode != null" >
        #{activityCode,jdbcType=VARCHAR},
      </if>
      <if test="activityVersion != null" >
        #{activityVersion,jdbcType=BIGINT},
      </if>
      <if test="activityTypeId != null" >
        #{activityTypeId,jdbcType=BIGINT},
      </if>
      <if test="channelId != null" >
        #{channelId,jdbcType=BIGINT},
      </if>
      <if test="activityName != null" >
        #{activityName,jdbcType=VARCHAR},
      </if>
      <if test="activityTitle != null" >
        #{activityTitle,jdbcType=VARCHAR},
      </if>
      <if test="activitySubTitle != null" >
        #{activitySubTitle,jdbcType=CHAR},
      </if>
      <if test="activityDesc != null" >
        #{activityDesc,jdbcType=VARCHAR},
      </if>
      <if test="ruleDesc != null" >
        #{ruleDesc,jdbcType=VARCHAR},
      </if>
      <if test="activityImg1 != null" >
        #{activityImg1,jdbcType=VARCHAR},
      </if>
      <if test="activityImg2 != null" >
        #{activityImg2,jdbcType=VARCHAR},
      </if>
      <if test="activityImg3 != null" >
        #{activityImg3,jdbcType=VARCHAR},
      </if>
      <if test="fromDate != null" >
        #{fromDate,jdbcType=CHAR},
      </if>
      <if test="thruDate != null" >
        #{thruDate,jdbcType=CHAR},
      </if>
      <if test="createTime != null" >
        #{createTime,jdbcType=CHAR},
      </if>
      <if test="activityAmount != null" >
        #{activityAmount,jdbcType=INTEGER},
      </if>
      <if test="isActive != null" >
        #{isActive,jdbcType=CHAR},
      </if>
    </trim>
  </insert>
  <update id="updateByPrimaryKeySelective" parameterType="com.bw.adv.module.activity.model.Activity" >
    update activity
    <set >
      <if test="activityCode != null" >
        ACTIVITY_CODE = #{activityCode,jdbcType=VARCHAR},
      </if>
      <if test="activityVersion != null" >
        ACTIVITY_VERSION = #{activityVersion,jdbcType=BIGINT},
      </if>
      <if test="activityTypeId != null" >
        ACTIVITY_TYPE_ID = #{activityTypeId,jdbcType=BIGINT},
      </if>
      <if test="channelId != null" >
        CHANNEL_ID = #{channelId,jdbcType=BIGINT},
      </if>
      <if test="activityName != null" >
        ACTIVITY_NAME = #{activityName,jdbcType=VARCHAR},
      </if>
      <if test="activityTitle != null" >
        ACTIVITY_TITLE = #{activityTitle,jdbcType=VARCHAR},
      </if>
      <if test="activitySubTitle != null" >
        ACTIVITY_SUB_TITLE = #{activitySubTitle,jdbcType=CHAR},
      </if>
      <if test="activityDesc != null" >
        ACTIVITY_DESC = #{activityDesc,jdbcType=VARCHAR},
      </if>
      <if test="ruleDesc != null" >
        RULE_DESC = #{ruleDesc,jdbcType=VARCHAR},
      </if>
      <if test="activityImg1 != null" >
        ACTIVITY_IMG_1 = #{activityImg1,jdbcType=VARCHAR},
      </if>
      <if test="activityImg2 != null" >
        ACTIVITY_IMG_2 = #{activityImg2,jdbcType=VARCHAR},
      </if>
      <if test="activityImg3 != null" >
        ACTIVITY_IMG_3 = #{activityImg3,jdbcType=VARCHAR},
      </if>
      <if test="fromDate != null" >
        FROM_DATE = #{fromDate,jdbcType=CHAR},
      </if>
      <if test="thruDate != null" >
        THRU_DATE = #{thruDate,jdbcType=CHAR},
      </if>
      <if test="createTime != null" >
        CREATE_TIME = #{createTime,jdbcType=CHAR},
      </if>
      <if test="activityAmount != null" >
        ACTIVITY_AMOUNT = #{activityAmount,jdbcType=INTEGER},
      </if>
      <if test="isActive != null" >
        IS_ACTIVE = #{isActive,jdbcType=CHAR},
      </if>
    </set>
    where ACTIVITY_ID = #{activityId,jdbcType=BIGINT}
  </update>
  <update id="updateByPrimaryKey" parameterType="com.bw.adv.module.activity.model.Activity" >
    update activity
    set ACTIVITY_CODE = #{activityCode,jdbcType=VARCHAR},
      ACTIVITY_VERSION = #{activityVersion,jdbcType=BIGINT},
      ACTIVITY_TYPE_ID = #{activityTypeId,jdbcType=BIGINT},
      CHANNEL_ID = #{channelId,jdbcType=BIGINT},
      ACTIVITY_NAME = #{activityName,jdbcType=VARCHAR},
      ACTIVITY_TITLE = #{activityTitle,jdbcType=VARCHAR},
      ACTIVITY_SUB_TITLE = #{activitySubTitle,jdbcType=CHAR},
      ACTIVITY_DESC = #{activityDesc,jdbcType=VARCHAR},
      RULE_DESC = #{ruleDesc,jdbcType=VARCHAR},
      ACTIVITY_IMG_1 = #{activityImg1,jdbcType=VARCHAR},
      ACTIVITY_IMG_2 = #{activityImg2,jdbcType=VARCHAR},
      ACTIVITY_IMG_3 = #{activityImg3,jdbcType=VARCHAR},
      FROM_DATE = #{fromDate,jdbcType=CHAR},
      THRU_DATE = #{thruDate,jdbcType=CHAR},
      CREATE_TIME = #{createTime,jdbcType=CHAR},
      ACTIVITY_AMOUNT = #{activityAmount,jdbcType=INTEGER},
      IS_ACTIVE = #{isActive,jdbcType=CHAR}
    where ACTIVITY_ID = #{activityId,jdbcType=BIGINT}
  </update>
</mapper>